%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% File: xmldom.oz
% Purpose: Implements DOM methods
% Current state: three methods are implemented which was needed in my applications.
% Date: 2000 11 28
% Revised: 2001 09 20 ==>
%          become namespace-aware
% Author: Mahmoud Rafea
% Copyright: Mahmoud Rafea
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%\define OPI
\ifdef OPI
declare
F =
\endif
functor
import
   Parser(xmlDoc:XMLDoc
	xmlScan:XMLScan
	scanXML:ScanXML
	key:Key) at 'parser.ozf'
   
export
   dom:DOM

define
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %% Transforms a Mozart xml representation into an xml string
   fun {XMLStr T Doc}
      fun {S2CD X}
	 if X == nil then "" else "<![CDATA["#X#"]]>" end
      end
      fun {T2S As}
	 case As of nil then ""
	 [] A#V#_#_|Ar then
	    ' '#A#'="'#V#'"'#{T2S Ar}
	 end
      end
   in
      case T
      of nil then nil
      [] r(attrs:As1 children:Cs data:D namespace:_ node:Key tag:Tag) then
	 CD = {S2CD {CondSelect {Dictionary.condGet {Doc get(cdata $)} Key nil} cdata nil}}
	 As = {T2S As1}
      in
	 if Cs == nil then
	    {VirtualString.toString "<"#Tag#As#">"#D#CD#"</"#Tag#">"}
	 else
	    {VirtualString.toString "<"#Tag#As#">"#D#CD#{XMLStr Cs Doc}#"</"#Tag#">"}
	 end
      [] R|Rs then
	 {VirtualString.toString {XMLStr R Doc}#{XMLStr Rs Doc}}
      else
	 raise xmlerror(T) end
      end
   end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   %%
   class DOM from XMLDoc
      attr
	 t
	 
      meth BuildOzTree(Parent $)
	 Ns = {List.sort {self getChildren(Parent $)} fun {$ X Y} X.n =< Y.n end}
      in
	 {Map Ns fun {$ N}
		    r(children:{self BuildOzTree(N.key $)}
		      node:N.key
		      data:{CondSelect {Dictionary.condGet @data N.key nil} data ""}
		      tag:N.name
		      attrs:{CondSelect {Dictionary.condGet @nattrs N.key nil} nattrs nil}
		      namespace:N.namespace)
		 end}
      end
      %%
      meth ozTree($)
	 DOM, updateTree($)
      end
      %%
      meth updateTree($)
	 Top = {Dictionary.condGet @nodes '00' nil} in
	 if Top == nil then t <- r(attrs:nil children:nil  namespace:'' node:nil tag:'')
	 else
	    t <- r(children:{self BuildOzTree('00' $)}
		   node:'00'
		   data:{CondSelect {Dictionary.condGet @data '00' nil} data ""}
		   tag:Top.name
		   attrs:{CondSelect {Dictionary.condGet @nattrs '00' nil} nattrs nil}
		   namespace:Top.namespace)
	 end
	 @t
      end
      %%
      meth getXML($)
	 if {IsDet @t} then
	    {XMLStr @t self}
	 else
	    {XMLStr (DOM, updateTree($)) self}
	 end
      end
      %%
      meth addNode(Parent Tag NameSpace Data $)
	 if Parent == 0 then
	    % It is the top node
	    {Dictionary.put @nodes '00' node(key:'00' name:Tag namespace:NameSpace parent:0 n:0)}
	    {Dictionary.put @data '00' node(key:'00' data:Data)}
	    '00'
	 else
	    AllNodes = {Dictionary.keys @nodes}
	    N = {List.length AllNodes}+1 
	    K = {Key} in
	    if NameSpace == '' then
	       R = @nodes.Parent in
	       {Dictionary.put @nodes K node(key:K name:Tag namespace:R.namespace parent:Parent n:N)}
	    else
	       {Dictionary.put @nodes K node(key:K name:Tag namespace:NameSpace parent:Parent n:N)}
	    end
	    {Dictionary.put @data K node(key:K data:Data)}
	    K
	 end
      end
      %%
      meth putNodeText(Node Text)
	 Data = {XMLScan Text} in
	 if {Dictionary.member @nodes Node} then
	    {Dictionary.put @data Node node(key:Node data:Data)}
	 else
	    raise xmlerror('Node key is invalid') end
	 end
      end
      %%
      meth getNodeText(Node Text)
	 if {Dictionary.member @nodes Node} then
	    R = {Dictionary.condGet @data Node nil} in
	    if R == nil then Text = ""
	    else Text = {ScanXML R.data} end
	 else
	    raise xmlerror('Node key is invalid') end
	 end
      end
      %%
   end
end

\ifdef OPI
[M] = {Module.apply [F]}

O = {New M.dom init}

{O loadXML("<a id=\"1\">data<b id='2'/><!-- Aladdin --></a>")}

{Browse {Dictionary.entries {O get(comments $)}}}

{Browse {O ozTree($)}}
\endif